diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -3182,14 +4292,53 @@ class YumBase(depsolve.Depsolve):
                         raise Errors.YumBaseError, _('Invalid version flag from: %s') % str(depstring)
                     depflags = SYMBOLFLAGS[flagsymbol]
 
+        if depflags is None: # This does wildcards...
+            return self.rpmdb.searchProvides(depstring)
+
+        # This does flags+versions, but no wildcards...
         return self.rpmdb.getProvides(depname, depflags, depver).keys()
 
-    def _bestPackageFromList(self, pkglist):
+    def returnInstalledPackageByDep(self, depstring):
+        """Return the best, or first, installed package object that provides the
+        given dependencies.
+
+        :param depstring: a string specifying the dependency to return
+           the package that fulfils
+        :return: the best, or first, installed package that fulfils the given
+           dependency
+        :raises: a :class:`yum.Errors.YumBaseError` if no packages that
+           fulfil the given dependency can be found
+        """
+        # we get all sorts of randomness here
+        errstring = depstring
+        if type(depstring) not in types.StringTypes:
+            errstring = str(depstring)
+        
+        try:
+            pkglist = self.returnInstalledPackagesByDep(depstring)
+        except Errors.YumBaseError:
+            raise Errors.YumBaseError, _('No Package found for %s') % errstring
+        
+        ps = ListPackageSack(pkglist)
+        result = self._bestPackageFromList(ps.returnNewestByNameArch(),
+                                           req=errstring)
+        if result is None:
+            raise Errors.YumBaseError, _('No Package found for %s') % errstring
+        
+        return result
+
+    def _bestPackageFromList(self, pkglist, req=None):
         """take list of package objects and return the best package object.
            If the list is empty, return None. 
            
            Note: this is not aware of multilib so make sure you're only
-           passing it packages of a single arch group."""
+           passing it packages of a single arch group.
+
+           :param pkglist: the list of packages to return the best
+             packages from
+           :param req: the requirement from the user
+           :return: a list of the best packages from *pkglist*
+        """
         
         
         if len(pkglist) == 0:
@@ -3198,14 +4347,23 @@ class YumBase(depsolve.Depsolve):
         if len(pkglist) == 1:
             return pkglist[0]
 
-        bestlist = self._compare_providers(pkglist, None)
+        bestlist = self._compare_providers(pkglist, reqpo=None, req=req)
         return bestlist[0][0]
 
-    def bestPackagesFromList(self, pkglist, arch=None, single_name=False):
-        """Takes a list of packages, returns the best packages.
-           This function is multilib aware so that it will not compare
-           multilib to singlelib packages""" 
-    
+    def bestPackagesFromList(self, pkglist, arch=None, single_name=False,
+                             req=None):
+        """Return the best packages from a list of packages.  This
+        function is multilib aware, so that it will not compare
+        multilib to singlelib packages.
+
+        :param pkglist: the list of packages to return the best
+           packages from
+        :param arch: packages will be selected that are compatible
+           with the architecture specified by *arch*
+        :param single_name: whether to return a single package name
+        :param req: the requirement from the user
+        :return: a list of the best packages from *pkglist*
+        """
         returnlist = []
         compatArchList = self.arch.get_arch_list(arch)
         multiLib = []
@@ -3222,9 +4380,9 @@ class YumBase(depsolve.Depsolve):
                 singleLib.append(po)
                 
         # we now have three lists.  find the best package(s) of each
-        multi = self._bestPackageFromList(multiLib)
-        single = self._bestPackageFromList(singleLib)
-        no = self._bestPackageFromList(noarch)
+        multi = self._bestPackageFromList(multiLib, req=req)
+        single = self._bestPackageFromList(singleLib, req=req)
+        no = self._bestPackageFromList(noarch, req=req)
 
         if single_name and multi and single and multi.name != single.name:
             # Sinlge _must_ match multi, if we want a single package name
@@ -3238,7 +4396,7 @@ class YumBase(depsolve.Depsolve):
         # if there's a noarch and it's newer than the multilib, we want
         # just the noarch.  otherwise, we want multi + single
         elif multi:
-            best = self._bestPackageFromList([multi,no])
+            best = self._bestPackageFromList([multi,no], req=req)
             if best.arch == "noarch":
                 returnlist.append(no)
             else:
@@ -3246,7 +4404,7 @@ class YumBase(depsolve.Depsolve):
                 if single: returnlist.append(single)
         # similar for the non-multilib case
         elif single:
-            best = self._bestPackageFromList([single,no])
+            best = self._bestPackageFromList([single,no], req=req)
             if best.arch == "noarch":
                 returnlist.append(no)
             else:
@@ -3350,28 +4508,71 @@ class YumBase(depsolve.Depsolve):
             done = True
 
             slow = next_func(slow)
-            if next == slow:
+            if node == slow:
                 return None
 
-    def _at_groupinstall(self, pattern):
-        " Do groupinstall via. leading @ on the cmd line, for install/update."
+    def _try_bold(self, string_):
+        """Attempt to make the string look bold in terminal."""
+        if hasattr(self, 'term'):
+            return '%s%s%s' % (self.term.MODE['bold'], string_, self.term.MODE['normal'])
+        return string_
+
+    def _at_groupinstall(self, pattern, upgrade=False):
+        " Do groupinstall via. leading @ on the cmd line, for install."
         assert pattern[0] == '@'
         group_string = pattern[1:]
         tx_return = []
-        for group in self.comps.return_groups(group_string):
-            try:
-                txmbrs = self.selectGroup(group.groupid)
+
+        try: comps = self.comps
+        except yum.Errors.GroupsError, e:
+            # No Groups Available in any repository?
+            # This also means no installed groups, when using objects.
+            self.logger.warning(e)
+            return tx_return
+
+        found = False
+        if group_string and group_string[0] == '^':
+            group_string = group_string[1:]
+            # Actually dealing with "environment groups".
+            for env_grp in comps.return_environments(group_string):
+                found = True
+                txmbrs = self.selectEnvironment(env_grp.environmentid,
+                                                upgrade=upgrade)
                 tx_return.extend(txmbrs)
-            except yum.Errors.GroupsError:
-                self.logger.critical(_('Warning: Group %s does not exist.'), group_string)
-                continue
+        else:
+            for group in comps.return_groups(group_string):
+                found = True
+                txmbrs = self.selectGroup(group.groupid, upgrade=upgrade)
+                tx_return.extend(txmbrs)
+        if not found:
+            raise Errors.GroupInstallError, _('Group %s does not exist.') % self._try_bold(group_string)
         return tx_return
-        
+
+    def _at_groupupgrade(self, pattern):
+        " Do group upgrade via. leading @ on the cmd line, for update."
+        try:
+            return self._at_groupinstall(pattern, upgrade=True)
+        except Errors.GroupInstallError, e:
+            self.logger.warning(_('Warning: %s'), e)
+            return []
+
     def _at_groupremove(self, pattern):
         " Do groupremove via. leading @ on the cmd line, for remove."
         assert pattern[0] == '@'
         group_string = pattern[1:]
         tx_return = []
+
+        if group_string and group_string[0] == '^':
+            group_string = group_string[1:]
+            # Actually dealing with "environment groups".
+            try:
+                txmbrs = self.environmentRemove(group_string)
+            except yum.Errors.GroupsError:
+                self.logger.critical(_('Warning: Environment Group %s does not exist.'), group_string)
+            else:
+                tx_return.extend(txmbrs)
+            return tx_return
+
         try:
             txmbrs = self.groupRemove(group_string)
         except yum.Errors.GroupsError:
@@ -3387,6 +4588,8 @@ class YumBase(depsolve.Depsolve):
         assert pattern[0] == '@'
         grpid = pattern[1:]
 
+        # FIXME: **** environment groups and groups as objects... ****
+
         thesegroups = self.comps.return_groups(grpid)
         if not thesegroups:
             raise Errors.GroupsError, _("No Group named %s exists") % to_unicode(grpid)
@@ -3398,7 +4601,11 @@ class YumBase(depsolve.Depsolve):
     def _minus_deselect(self, pattern):
         """ Remove things from the transaction, like kickstart. """
         assert pattern[0] == '-'
-        pat = pattern[1:]
+        pat = pattern[1:].strip()
+
+        if pat and pat.startswith('@^'):
+            pat = pat[2:]
+            return self.deselectEnvironment(pat)
 
         if pat and pat[0] == '@':
             pat = pat[1:]
@@ -3437,14 +4644,87 @@ class YumBase(depsolve.Depsolve):
             if flag not in self.tsInfo.probFilterFlags:
                 self.tsInfo.probFilterFlags.append(flag)
 
+    def _install_is_upgrade(self, po, ipkgs):
+        """ See if po is an upgradeable version of an installed pkg.
+        Non-compat. arch differences mean no. """
+
+        if False and self._up is not None:
+            #  This is the old code, not sure it's good to have two paths. And
+            # we don't want to create .up. (which requires init repos.) if we
+            # don't have to.
+            return po.pkgtup in self.up.updating_dict
+
+        for ipkg in ipkgs:
+            if po.verLE(ipkg):
+                continue
+            if po.arch == ipkg.arch: # always fine.
+                return True
+            if 'noarch' in (po.arch, ipkg.arch):
+                return True
+            if not self.arch.multilib:
+                return True
+            if canCoinstall(po.arch, ipkg.arch):
+                continue
+            return True
+
+        return False
+
+    def _valid_install_arch(self, po, ipkgs=None):
+        ''' See if we can install this arch of package, mainly for
+            i386 vs. i586 or ppc64 vs. ppc64 etc. '''
+        if not ipkgs:
+            ipkgs = self.rpmdb.searchNames([po.name])
+        else:
+            ipkgs = ipkgs[:]
+
+        # Add these anyway, just to be sure.
+        for txmbr in self.tsInfo.matchNaevr(po.name):
+            if txmbr.output_state not in TS_INSTALL_STATES:
+                continue
+            ipkgs.append(txmbr.po)
+
+        for ipkg in ipkgs:
+            if po.arch == ipkg.arch:
+                continue
+            if not po.verEQ(ipkg):
+                continue
+            if canCoinstall(po.arch, ipkg.arch):
+                continue
+            self.verbose_logger.log(logginglevels.INFO_2,
+                    _("Package: %s - can't co-install with %s"), po, ipkg)
+            return False
+        return True
+
     def install(self, po=None, **kwargs):
-        """try to mark for install the item specified. Uses provided package 
-           object, if available. If not it uses the kwargs and gets the best
-           packages from the keyword options provided 
-           returns the list of txmbr of the items it installs
-           
-           """
+        """Mark the specified item for installation.  If a package
+        object is given, mark it for installation.  Otherwise, mark
+        the best package specified by the key word arguments for
+        installation.
+
+        :param po: a package object to install
+        :param kwargs: if *po* is not specified, these keyword
+           arguments will be used to find the best package to install
+        :return: a list of the transaction members added to the
+           transaction set by this function
+        :raises: :class:`yum.Errors.InstallError` if there is a problem
+           installing the package
+        """
         
+
+        #  This is kind of hacky, we really need a better way to do errors than
+        # doing them directly from .install/etc. ... but this is easy. *sigh*.
+        #  We are only using this in "groupinstall" atm. ... so we don't have
+        # a long list of "blah already installed." messages when people run
+        # "groupinstall mygroup" in yum-cron etc.
+        pkg_warn = kwargs.get('pkg_warning_level', 'flibble')
+        def _dbg2(*args, **kwargs):
+            self.verbose_logger.log(logginglevels.DEBUG_2, *args, **kwargs)
+        level2func = {'debug2' : _dbg2,
+                      'warning' : self.verbose_logger.warning}
+        if pkg_warn not in level2func:
+            pkg_warn = 'warning'
+        pkg_warn = level2func[pkg_warn]
+
         pkgs = []
         was_pattern = False
         if po:
@@ -3464,9 +4744,14 @@ class YumBase(depsolve.Depsolve):
                 if kwargs['pattern'] and kwargs['pattern'][0] == '@':
                     return self._at_groupinstall(kwargs['pattern'])
 
+                repoid = None # All of them
+                if 'repoid' in kwargs:
+                    repoid = kwargs['repoid']
+
                 was_pattern = True
                 pats = [kwargs['pattern']]
                 mypkgs = self.pkgSack.returnPackages(patterns=pats,
+                                                     repoid=repoid,
                                                       ignore_case=False)
                 pkgs.extend(mypkgs)
                 # if we have anything left unmatched, let's take a look for it
@@ -3477,20 +4762,14 @@ class YumBase(depsolve.Depsolve):
                     self.verbose_logger.debug(_('Checking for virtual provide or file-provide for %s'), 
                         arg)
 
-                    try:
-                        mypkgs = self.returnPackagesByDep(arg)
-                    except yum.Errors.YumBaseError, e:
-                        self.logger.critical(_('No Match for argument: %s') % to_unicode(arg))
-                    else:
-                        # install MTA* == fail, because provides don't do globs
-                        # install /usr/kerberos/bin/* == success (and we want
-                        #                                all of the pkgs)
-                        if mypkgs and not misc.re_glob(arg):
-                            mypkgs = self.bestPackagesFromList(mypkgs,
-                                                               single_name=True)
-                        if mypkgs:
-                            pkgs.extend(mypkgs)
-                        
+                    mypkgs = self.returnPackagesByDep(arg)
+                    if repoid:
+                        mypkgs = misc.filter_pkgs_repoid(mypkgs, repoid)
+                    if not misc.re_glob(arg):
+                        mypkgs = self.bestPackagesFromList(mypkgs,
+                                                           single_name=True,
+                                                           req=arg)
+                    pkgs.extend(mypkgs)
             else:
                 nevra_dict = self._nevra_kwarg_parse(kwargs)
 
@@ -3499,6 +4778,8 @@ class YumBase(depsolve.Depsolve):
                      ver=nevra_dict['version'], rel=nevra_dict['release'])
                 self._add_not_found_a(pkgs, nevra_dict)
                 
+                pkgs = misc.filter_pkgs_repoid(pkgs, kwargs.get('repoid'))
+
             if pkgs:
                 # if was_pattern or nevra-dict['arch'] is none, take the list
                 # of arches based on our multilib_compat config and 
@@ -3577,17 +4858,21 @@ class YumBase(depsolve.Depsolve):
                     continue
             
             # make sure this shouldn't be passed to update:
-            if (self.rpmdb.searchNames([po.name]) and
-                po.pkgtup in self.up.updating_dict):
-                txmbrs = self.update(po=po)
+            ipkgs = self.rpmdb.searchNames([po.name])
+            if ipkgs and self._install_is_upgrade(po, ipkgs):
+                txmbrs = self.update(po=po, repoid=kwargs.get('repoid'))
                 tx_return.extend(txmbrs)
                 continue
+
+            if not self._valid_install_arch(po, ipkgs):
+                continue
             
             #  Make sure we're not installing a package which is obsoleted by
             # something else in the repo. Unless there is a obsoletion loop,
             # at which point ignore everything.
+            # NOTE: This is broken wrt. repoid...
             obsoleting_pkg = None
-            if self.conf.obsoletes:
+            if self.conf.obsoletes and not isinstance(po, YumLocalPackage):
                 obsoleting_pkg = self._test_loop(po, self._pkg2obspkg)
             if obsoleting_pkg is not None:
                 # this is not a definitive check but it'll make sure we don't
@@ -3600,23 +4885,23 @@ class YumBase(depsolve.Depsolve):
                     already_obs = pkgs[0]
 
                 if already_obs:
-                    self.verbose_logger.warning(_('Package %s is obsoleted by %s which is already installed'), 
-                                                po, already_obs)
+                    pkg_warn(_('Package %s is obsoleted by %s which is already installed'), 
+                             po, already_obs)
                 else:
                     if 'provides_for' in kwargs:
                         if not obsoleting_pkg.provides_for(kwargs['provides_for']):
-                            self.verbose_logger.warning(_('Package %s is obsoleted by %s, but obsoleting package does not provide for requirements'),
-                                                  po.name, obsoleting_pkg.name)
+                            pkg_warn(_('Package %s is obsoleted by %s, but obsoleting package does not provide for requirements'),
+                                     po.name, obsoleting_pkg.name)
                             continue
-                    self.verbose_logger.warning(_('Package %s is obsoleted by %s, trying to install %s instead'),
-                        po.name, obsoleting_pkg.name, obsoleting_pkg)
+                    pkg_warn(_('Package %s is obsoleted by %s, trying to install %s instead'),
+                             po.name, obsoleting_pkg.name, obsoleting_pkg)
                     tx_return.extend(self.install(po=obsoleting_pkg))
                 continue
             
             # make sure it's not already installed
             if self.rpmdb.contains(po=po):
                 if not self.tsInfo.getMembersWithState(po.pkgtup, TS_REMOVE_STATES):
-                    self.verbose_logger.warning(_('Package %s already installed and latest version'), po)
+                    pkg_warn(_('Package %s already installed and latest version'), po)
                     continue
 
             # make sure we don't have a name.arch of this already installed
@@ -3630,8 +4915,8 @@ class YumBase(depsolve.Depsolve):
                         found = True
                         break
                 if not found:
-                    self.verbose_logger.warning(_('Package matching %s already installed. Checking for update.'), po)            
-                    txmbrs = self.update(po=po)
+                    pkg_warn(_('Package matching %s already installed. Checking for update.'), po)            
+                    txmbrs = self.update(po=po, repoid=kwargs.get('repoid'))
                     tx_return.extend(txmbrs)
                     continue
 
@@ -3719,19 +5004,47 @@ class YumBase(depsolve.Depsolve):
         return txmbr
 
     def update(self, po=None, requiringPo=None, update_to=False, **kwargs):
-        """try to mark for update the item(s) specified. 
-            po is a package object - if that is there, mark it for update,
-            if possible
-            else use **kwargs to match the package needing update
-            if nothing is specified at all then attempt to update everything
+        """Mark the specified items to be updated.  If a package
+        object is given, mark it.  Else, if a package is specified by
+        the keyword arguments, mark it.  Finally, if nothing is given,
+        mark all installed packages to be updated.
+
+
+        :param po: the package object to be marked for updating
+        :param requiringPo: the package object that requires the
+           upgrade
+        :param update_to: if *update_to* is True, the update will only
+           be run if it will update the given package to the given
+           version.  For example, if the package foo-1-2 is installed,::
+
+             updatePkgs(["foo-1-2"], update_to=False)
+           will work identically to::
             
-            returns the list of txmbr of the items it marked for update"""
-        
+             updatePkgs(["foo"])
+           but::
+
+             updatePkgs(["foo-1-2"], update_to=True)
+           
+           will do nothing
+        :param kwargs: if *po* is not given, the names or wildcards in
+           *kwargs* will be used to find the packages to update
+        :return: a list of transaction members added to the
+           transaction set by this function
+        """
         # check for args - if no po nor kwargs, do them all
         # if po, do it, ignore all else
         # if no po do kwargs
         # uninstalled pkgs called for update get returned with errors in a list, maybe?
 
+        pkg_warn = kwargs.get('pkg_warning_level', 'flibble')
+        def _dbg2(*args, **kwargs):
+            self.verbose_logger.log(logginglevels.DEBUG_2, *args, **kwargs)
+        level2func = {'debug2' : _dbg2,
+                      'warning' : self.verbose_logger.warning}
+        if pkg_warn not in level2func:
+            pkg_warn = 'warning'
+        pkg_warn = level2func[pkg_warn]
+
         tx_return = []
         if not po and not kwargs: # update everything (the easy case)
             self.verbose_logger.log(logginglevels.DEBUG_2, _('Updating Everything'))
@@ -3765,7 +5078,15 @@ class YumBase(depsolve.Depsolve):
                     if new is None:
                         continue
                     tx_return.extend(self.update(po=new))
-            
+
+            # Upgrade the installed groups, as part of generic "yum upgrade"
+            if (self.conf.group_command == 'objects' and
+                self.conf.upgrade_group_objects_upgrade):
+                for ievgrp in self.igroups.environments:
+                    tx_return.extend(self._at_groupupgrade('@^' + ievgrp))
+                for igrp in self.igroups.groups:
+                    tx_return.extend(self._at_groupupgrade('@'  + igrp))
+
             return tx_return
 
         # complications
@@ -3787,13 +5108,16 @@ class YumBase(depsolve.Depsolve):
                 return self._minus_deselect(kwargs['pattern'])
 
             if kwargs['pattern'] and kwargs['pattern'][0] == '@':
-                return self._at_groupinstall(kwargs['pattern'])
+                return self._at_groupupgrade(kwargs['pattern'])
 
             arg = kwargs['pattern']
             if not update_to:
                 instpkgs  = self.rpmdb.returnPackages(patterns=[arg])
+                instpkgs  = misc.filter_pkgs_repoid(instpkgs,
+                                                    kwargs.get('repoid'))
             else:
-                availpkgs = self.pkgSack.returnPackages(patterns=[arg])
+                availpkgs = self.pkgSack.returnPackages(patterns=[arg],
+                                                        repoid=kwargs.get('repoid'))
 
             if not instpkgs and not availpkgs:
                 depmatches = []
@@ -3805,6 +5129,8 @@ class YumBase(depsolve.Depsolve):
                 except yum.Errors.YumBaseError, e:
                     self.logger.critical(_('%s') % e)
 
+                depmatches = misc.filter_pkgs_repoid(depmatches,
+                                                     kwargs.get('repoid'))
                 if update_to:
                     availpkgs.extend(depmatches)
                 else:
@@ -3816,9 +5142,12 @@ class YumBase(depsolve.Depsolve):
             try:
                 if update_to:
                     m = []
+                elif kwargs.get('repoid'):
+                    pats = [kwargs['pattern']]
+                    m = self.pkgSack.sacks[kwargs['repoid']]
+                    m = m.returnNewestByNameArch(patterns=pats)
                 else:
                     pats = [kwargs['pattern']]
-                    # pats += list(set([pkg.name for pkg in instpkgs]))
                     m = self.pkgSack.returnNewestByNameArch(patterns=pats)
             except Errors.PackageSackError:
                 m = []
@@ -3843,7 +5172,7 @@ class YumBase(depsolve.Depsolve):
                     availpkgs = self._compare_providers(availpkgs, requiringPo)
                     availpkgs = map(lambda x: x[0], availpkgs)
                 elif not availpkgs:
-                    self.logger.warning(_("No package matched to upgrade: %s"), self._ui_nevra_dict(nevra_dict))
+                    pkg_warn(_("No package matched to upgrade: %s"), self._ui_nevra_dict(nevra_dict))
        
         # for any thing specified
         # get the list of available pkgs matching it (or take the po)
@@ -3879,6 +5208,7 @@ class YumBase(depsolve.Depsolve):
                     if obsoleting_pkg is None:
                         continue
                     obs_pkgs.append(obsoleting_pkg)
+                # NOTE: Broekn wrt. repoid
                 for obsoleting_pkg in packagesNewestByName(obs_pkgs):
                     tx_return.extend(self.install(po=obsoleting_pkg))
             for available_pkg in availpkgs:
@@ -3920,11 +5250,29 @@ class YumBase(depsolve.Depsolve):
                     tx_return.append(txmbr)
                         
         for available_pkg in availpkgs:
+            if not self._valid_install_arch(available_pkg):
+                continue
+
+            # "Just do it" if it's a local pkg.
+            if isinstance(available_pkg, YumLocalPackage):
+                n = available_pkg.name
+                for updated_pkg in self.rpmdb.returnNewestByName(n):
+                    updated = updated_pkg.pkgtup
+                    if self.tsInfo.getMembersWithState(updated,
+                                                       TS_REMOVE_STATES):
+                        self.tsInfo.remove(updated)
+                    txmbr = self._add_up_txmbr(requiringPo,
+                                               available_pkg, updated_pkg)
+                    tx_return.append(txmbr)
+                continue
             #  Make sure we're not installing a package which is obsoleted by
             # something else in the repo. Unless there is a obsoletion loop,
             # at which point ignore everything.
             obsoleting_pkg = self._test_loop(available_pkg, self._pkg2obspkg)
             if obsoleting_pkg is not None:
+                if (kwargs.get('repoid') and
+                    obsoleting_pkg.repoid != kwargs.get('repoid')):
+                    continue # Meh.
                 self.verbose_logger.log(logginglevels.DEBUG_2, _('Not Updating Package that is obsoleted: %s'), available_pkg)
                 tx_return.extend(self.update(po=obsoleting_pkg))
                 continue
@@ -3985,11 +5333,18 @@ class YumBase(depsolve.Depsolve):
         return tx_return
         
     def remove(self, po=None, **kwargs):
-        """try to find and mark for remove the specified package(s) -
-            if po is specified then that package object (if it is installed) 
-            will be marked for removal.
-            if no po then look at kwargs, if neither then raise an exception"""
-
+        """Mark the specified packages for removal. If a package
+        object is given, mark it for removal.  Otherwise, mark the
+        package specified by the keyword arguments.
+
+        :param po: the package object to mark for installation
+        :param kwargs: If *po* is not given, the keyword arguments
+           will be used to specify a package to mark for installation
+        :return: a list of the transaction members that were added to
+           the transaction set by this method
+        :raises: :class:`yum.Errors.RemoveError` if nothing is specified
+           to mark for removal
+        """
         if not po and not kwargs:
             raise Errors.RemoveError, 'Nothing specified to remove'
         
@@ -4008,6 +5363,10 @@ class YumBase(depsolve.Depsolve):
                     return self._at_groupremove(kwargs['pattern'])
 
                 (e,m,u) = self.rpmdb.matchPackageNames([kwargs['pattern']])
+                if 'repoid' in kwargs:
+                    e = misc.filter_pkgs_repoid(e, kwargs['repoid'])
+                    m = misc.filter_pkgs_repoid(m, kwargs['repoid'])
+
                 pkgs.extend(e)
                 pkgs.extend(m)
                 if u:
@@ -4018,6 +5377,10 @@ class YumBase(depsolve.Depsolve):
                     except yum.Errors.YumBaseError, e:
                         self.logger.critical(_('%s') % e)
                     
+                    if 'repoid' in kwargs:
+                        depmatches = misc.filter_pkgs_repoid(depmatches,
+                                                             kwargs['repoid'])
+
                     if not depmatches:
                         arg = to_unicode(arg)
                         self.logger.critical(_('No Match for argument: %s') % to_unicode(arg))
@@ -4055,17 +5418,19 @@ class YumBase(depsolve.Depsolve):
         return tx_return
 
     def installLocal(self, pkg, po=None, updateonly=False):
+        """Mark a package on the local filesystem (i.e. not from a
+        repository) for installation. 
+        
+        :param pkg: a string specifying the path to an rpm file in the
+           local filesystem to be marked for installation
+        :param po: a :class:`yum.packages.YumLocalPackage` 
+        :param updateonly: if True, the given package will only be
+           marked for installation if it is an upgrade for a package
+           that is already installed.  If False, this restriction is
+           not enforced
+        :return: a list of the transaction members added to the
+           transaction set by this method
         """
-        handles installs/updates of rpms provided on the filesystem in a
-        local dir (ie: not from a repo)
-
-        Return the added transaction members.
-
-        @param pkg: a path to an rpm file on disk.
-        @param po: A YumLocalPackage
-        @param updateonly: Whether or not true installs are valid.
-        """
-
         # read in the package into a YumLocalPackage Object
         # append it to self.localPackages
         # check if it can be installed or updated based on nevra versus rpmdb
